/* Problem URL: https://codeforces.com/edu/course/2/lesson/7/1/practice/contest/289390/problem/E */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;

    V<array<int, 2>> graph(n);

    rep(i, n) {
        int a, b;
        cin >> a >> b;

        graph[i] = {a - 1, b - 1};
    }

    V<tuple<int, int, int>> edges(m);

    while (m--) {
        int i, p;
        cin >> i >> p;
        i--, p--;

        edges[m] = {i, p, graph[i][p]};
        graph[i][p] = -1;
    }

    vi dsu(n);
    V<set<int>> nodes(n);
    rep(i, n) {
        dsu[i] = i;
        nodes[i].insert(i);
    }

    function<int(int)> find_p = [&](int i) {
        if (dsu[i] == i) {
            return i;
        }
        return dsu[i] = find_p(dsu[i]);
    };

    auto join = [&](int a, int b) {
        a = find_p(a);
        b = find_p(b);

        if (a == b) {
            return;
        }

        if (a > b) {
            swap(a, b);
        }

        if (nodes[a].size() < nodes[b].size()) {
            swap(nodes[a], nodes[b]);
        }

        repv(i, nodes[b]) {
            nodes[a].insert(i);
        }
        nodes[b].clear();

        dsu[b] = a;
    };

    rep(i, n) {
        if(graph[i][0] >= 0) {
            join(i, graph[i][0]);
        }

        if (graph[i][1] >= 0) {
            join(i, graph[i][1]);
        }
    }

    vi ans(n, -1);

    rep(k, edges.size()) {
        auto [i, p, j] = edges[k];

        i = find_p(i);
        j = find_p(j);

        if (i != j) {
            if (i > j) {
                swap(i, j);
            }

            if (i == 0) {
                repv(l, nodes[j]) {
                    ans[l] = edges.size() - k - 1;
                }
            }

            join(i, j);
        }
    }

    repv(i, ans) {
        cout << i << '\n';
    }
}
